# Source Generated with Decompyle++
# File: in.pyo (Python 2.5)

from lxml import etree
import sys
import re
import doctest
import cgi
__all__ = [
    'PARSE_HTML',
    'PARSE_XML',
    'NOPARSE_MARKUP',
    'LXMLOutputChecker',
    'LHTMLOutputChecker',
    'install',
    'temp_install']

try:
    _basestring = basestring
except NameError:
    _basestring = (str, bytes)

_IS_PYTHON_3 = sys.version_info[0] >= 3
PARSE_HTML = doctest.register_optionflag('PARSE_HTML')
PARSE_XML = doctest.register_optionflag('PARSE_XML')
NOPARSE_MARKUP = doctest.register_optionflag('NOPARSE_MARKUP')
OutputChecker = doctest.OutputChecker

def strip(v):
    if v is None:
        return None
    else:
        return v.strip()


def norm_whitespace(v):
    return _norm_whitespace_re.sub(' ', v)

_html_parser = etree.HTMLParser(recover = False, remove_blank_text = True)

def html_fromstring(html):
    return etree.fromstring(html, _html_parser)

_repr_re = re.compile('^<[^>]+ (at|object) ')
_norm_whitespace_re = re.compile('[ \\t\\n][ \\t\\n]+')

class LXMLOutputChecker(OutputChecker):
    empty_tags = ('param', 'img', 'area', 'br', 'basefont', 'input', 'base', 'meta', 'link', 'col')
    
    def get_default_parser(self):
        return etree.XML

    
    def check_output(self, want, got, optionflags):
        alt_self = getattr(self, '_temp_override_self', None)
        if alt_self is not None:
            super_method = self._temp_call_super_check_output
            self = alt_self
        else:
            super_method = OutputChecker.check_output
        parser = self.get_parser(want, got, optionflags)
        if not parser:
            return super_method(self, want, got, optionflags)
        
        
        try:
            want_doc = parser(want)
        except etree.XMLSyntaxError:
            return False

        
        try:
            got_doc = parser(got)
        except etree.XMLSyntaxError:
            return False

        return self.compare_docs(want_doc, got_doc)

    
    def get_parser(self, want, got, optionflags):
        parser = None
        if NOPARSE_MARKUP & optionflags:
            return None
        
        if PARSE_HTML & optionflags:
            parser = html_fromstring
        elif PARSE_XML & optionflags:
            parser = etree.XML
        elif want.strip().lower().startswith('<html') and got.strip().startswith('<html'):
            parser = html_fromstring
        elif self._looks_like_markup(want) and self._looks_like_markup(got):
            parser = self.get_default_parser()
        
        return parser

    
    def _looks_like_markup(self, s):
        s = s.strip()
        if s.startswith('<'):
            pass
        return not _repr_re.search(s)

    
    def compare_docs(self, want, got):
        if not self.tag_compare(want.tag, got.tag):
            return False
        
        if not self.text_compare(want.text, got.text, True):
            return False
        
        if not self.text_compare(want.tail, got.tail, True):
            return False
        
        if 'any' not in want.attrib:
            want_keys = sorted(want.attrib.keys())
            got_keys = sorted(got.attrib.keys())
            if want_keys != got_keys:
                return False
            
            for key in want_keys:
                if not self.text_compare(want.attrib[key], got.attrib[key], False):
                    return False
                    continue
            
        
        if want.text != '...' or len(want):
            want_children = list(want)
            got_children = list(got)
            while want_children or got_children:
                if not want_children or not got_children:
                    return False
                
                want_first = want_children.pop(0)
                got_first = got_children.pop(0)
                if not self.compare_docs(want_first, got_first):
                    return False
                
                if not got_children and want_first.tail == '...':
                    break
                    continue
        
        return True

    
    def text_compare(self, want, got, strip):
        if not want:
            pass
        want = ''
        if not got:
            pass
        got = ''
        if strip:
            want = norm_whitespace(want).strip()
            got = norm_whitespace(got).strip()
        
        want = '^%s$' % re.escape(want)
        want = want.replace('\\.\\.\\.', '.*')
        if re.search(want, got):
            return True
        else:
            return False

    
    def tag_compare(self, want, got):
        if want == 'any':
            return True
        
        if not isinstance(want, _basestring) or not isinstance(got, _basestring):
            return want == got
        
        if not want:
            pass
        want = ''
        if not got:
            pass
        got = ''
        if want.startswith('{...}'):
            return want.split('}')[-1] == got.split('}')[-1]
        else:
            return want == got

    
    def output_difference(self, example, got, optionflags):
        want = example.want
        parser = self.get_parser(want, got, optionflags)
        errors = []
        if parser is not None:
            
            try:
                want_doc = parser(want)
            except etree.XMLSyntaxError:
                e = sys.exc_info()[1]
                errors.append('In example: %s' % e)

            
            try:
                got_doc = parser(got)
            except etree.XMLSyntaxError:
                e = sys.exc_info()[1]
                errors.append('In actual output: %s' % e)
            except:
                None<EXCEPTION MATCH>etree.XMLSyntaxError
            

        None<EXCEPTION MATCH>etree.XMLSyntaxError
        if parser is None or errors:
            value = OutputChecker.output_difference(self, example, got, optionflags)
            if errors:
                errors.append(value)
                return '\n'.join(errors)
            else:
                return value
        
        html = parser is html_fromstring
        diff_parts = []
        diff_parts.append('Expected:')
        diff_parts.append(self.format_doc(want_doc, html, 2))
        diff_parts.append('Got:')
        diff_parts.append(self.format_doc(got_doc, html, 2))
        diff_parts.append('Diff:')
        diff_parts.append(self.collect_diff(want_doc, got_doc, html, 2))
        return '\n'.join(diff_parts)

    
    def html_empty_tag(self, el, html = True):
        if not html:
            return False
        
        if el.tag not in self.empty_tags:
            return False
        
        if el.text or len(el):
            return False
        
        return True

    
    def format_doc(self, doc, html, indent, prefix = ''):
        parts = []
        if not len(doc):
            parts.append(' ' * indent)
            parts.append(prefix)
            parts.append(self.format_tag(doc))
            if not self.html_empty_tag(doc, html):
                if strip(doc.text):
                    parts.append(self.format_text(doc.text))
                
                parts.append(self.format_end_tag(doc))
            
            if strip(doc.tail):
                parts.append(self.format_text(doc.tail))
            
            parts.append('\n')
            return ''.join(parts)
        
        parts.append(' ' * indent)
        parts.append(prefix)
        parts.append(self.format_tag(doc))
        if not self.html_empty_tag(doc, html):
            parts.append('\n')
            if strip(doc.text):
                parts.append(' ' * indent)
                parts.append(self.format_text(doc.text))
                parts.append('\n')
            
            for el in doc:
                parts.append(self.format_doc(el, html, indent + 2))
            
            parts.append(' ' * indent)
            parts.append(self.format_end_tag(doc))
            parts.append('\n')
        
        if strip(doc.tail):
            parts.append(' ' * indent)
            parts.append(self.format_text(doc.tail))
            parts.append('\n')
        
        return ''.join(parts)

    
    def format_text(self, text, strip = True):
        if text is None:
            return ''
        
        if strip:
            text = text.strip()
        
        return cgi.escape(text, 1)

    
    def format_tag(self, el):
        attrs = []
        if isinstance(el, etree.CommentBase):
            return '<!--'
        
        for name, value in sorted(el.attrib.items()):
            attrs.append('%s="%s"' % (name, self.format_text(value, False)))
        
        if not attrs:
            return '<%s>' % el.tag
        
        return '<%s %s>' % (el.tag, ' '.join(attrs))

    
    def format_end_tag(self, el):
        if isinstance(el, etree.CommentBase):
            return '-->'
        
        return '</%s>' % el.tag

    
    def collect_diff(self, want, got, html, indent):
        parts = []
        if not len(want) and not len(got):
            parts.append(' ' * indent)
            parts.append(self.collect_diff_tag(want, got))
            if not self.html_empty_tag(got, html):
                parts.append(self.collect_diff_text(want.text, got.text))
                parts.append(self.collect_diff_end_tag(want, got))
            
            parts.append(self.collect_diff_text(want.tail, got.tail))
            parts.append('\n')
            return ''.join(parts)
        
        parts.append(' ' * indent)
        parts.append(self.collect_diff_tag(want, got))
        parts.append('\n')
        if strip(want.text) or strip(got.text):
            parts.append(' ' * indent)
            parts.append(self.collect_diff_text(want.text, got.text))
            parts.append('\n')
        
        want_children = list(want)
        got_children = list(got)
        while want_children or got_children:
            if not want_children:
                parts.append(self.format_doc(got_children.pop(0), html, indent + 2, '-'))
                continue
            
            if not got_children:
                parts.append(self.format_doc(want_children.pop(0), html, indent + 2, '+'))
                continue
            
            parts.append(self.collect_diff(want_children.pop(0), got_children.pop(0), html, indent + 2))
        parts.append(' ' * indent)
        parts.append(self.collect_diff_end_tag(want, got))
        parts.append('\n')
        if strip(want.tail) or strip(got.tail):
            parts.append(' ' * indent)
            parts.append(self.collect_diff_text(want.tail, got.tail))
            parts.append('\n')
        
        return ''.join(parts)

    
    def collect_diff_tag(self, want, got):
        if not self.tag_compare(want.tag, got.tag):
            tag = '%s (got: %s)' % (want.tag, got.tag)
        else:
            tag = got.tag
        attrs = []
        if not want.tag == 'any':
            pass
        any = 'any' in want.attrib
        for name, value in sorted(got.attrib.items()):
            if name not in want.attrib and not any:
                attrs.append('-%s="%s"' % (name, self.format_text(value, False)))
                continue
            if name in want.attrib:
                text = self.collect_diff_text(value, want.attrib[name], False)
            else:
                text = self.format_text(value, False)
            attrs.append('%s="%s"' % (name, text))
        
        if not any:
            for name, value in sorted(want.attrib.items()):
                if name in got.attrib:
                    continue
                
                attrs.append('+%s="%s"' % (name, self.format_text(value, False)))
            
        
        if attrs:
            tag = '<%s %s>' % (tag, ' '.join(attrs))
        else:
            tag = '<%s>' % tag
        return tag

    
    def collect_diff_end_tag(self, want, got):
        if want.tag != got.tag:
            tag = '%s (got: %s)' % (want.tag, got.tag)
        else:
            tag = got.tag
        return '</%s>' % tag

    
    def collect_diff_text(self, want, got, strip = True):
        if self.text_compare(want, got, strip):
            if not got:
                return ''
            
            return self.format_text(got, strip)
        
        text = '%s (got: %s)' % (want, got)
        return self.format_text(text, strip)



class LHTMLOutputChecker(LXMLOutputChecker):
    
    def get_default_parser(self):
        return html_fromstring



def install(html = False):
    if html:
        doctest.OutputChecker = LHTMLOutputChecker
    else:
        doctest.OutputChecker = LXMLOutputChecker


def temp_install(html = False, del_module = None):
    if html:
        Checker = LHTMLOutputChecker
    else:
        Checker = LXMLOutputChecker
    frame = _find_doctest_frame()
    dt_self = frame.f_locals['self']
    checker = Checker()
    old_checker = dt_self._checker
    dt_self._checker = checker
    if _IS_PYTHON_3:
        check_func = frame.f_locals['check'].__func__
        checker_check_func = checker.check_output.__func__
    else:
        check_func = frame.f_locals['check'].im_func
        checker_check_func = checker.check_output.im_func
    doctest.etree = etree
    _RestoreChecker(dt_self, old_checker, checker, check_func, checker_check_func, del_module)


class _RestoreChecker(object):
    
    def __init__(self, dt_self, old_checker, new_checker, check_func, clone_func, del_module):
        self.dt_self = dt_self
        self.checker = old_checker
        self.checker._temp_call_super_check_output = self.call_super
        self.checker._temp_override_self = new_checker
        self.check_func = check_func
        self.clone_func = clone_func
        self.del_module = del_module
        self.install_clone()
        self.install_dt_self()

    
    def install_clone(self):
        if _IS_PYTHON_3:
            self.func_code = self.check_func.__code__
            self.func_globals = self.check_func.__globals__
            self.check_func.__code__ = self.clone_func.__code__
        else:
            self.func_code = self.check_func.func_code
            self.func_globals = self.check_func.func_globals
            self.check_func.func_code = self.clone_func.func_code

    
    def uninstall_clone(self):
        if _IS_PYTHON_3:
            self.check_func.__code__ = self.func_code
        else:
            self.check_func.func_code = self.func_code

    
    def install_dt_self(self):
        self.prev_func = self.dt_self._DocTestRunner__record_outcome
        self.dt_self._DocTestRunner__record_outcome = self

    
    def uninstall_dt_self(self):
        self.dt_self._DocTestRunner__record_outcome = self.prev_func

    
    def uninstall_module(self):
        if self.del_module:
            import sys
            del sys.modules[self.del_module]
            if '.' in self.del_module:
                (package, module) = self.del_module.rsplit('.', 1)
                package_mod = sys.modules[package]
                delattr(package_mod, module)
            
        

    
    def __call__(self, *args, **kw):
        self.uninstall_clone()
        self.uninstall_dt_self()
        del self.checker._temp_override_self
        del self.checker._temp_call_super_check_output
        result = self.prev_func(*args, **kw)
        self.uninstall_module()
        return result

    
    def call_super(self, *args, **kw):
        self.uninstall_clone()
        
        try:
            return self.check_func(*args, **kw)
        finally:
            self.install_clone()




def _find_doctest_frame():
    import sys
    frame = sys._getframe(1)
    while frame:
        l = frame.f_locals
        if 'BOOM' in l:
            return frame
        
        frame = frame.f_back
    raise LookupError('Could not find doctest (only use this function *inside* a doctest)')

__test__ = {
    'basic': '\n    >>> temp_install()\n    >>> print """<xml a="1" b="2">stuff</xml>"""\n    <xml b="2" a="1">...</xml>\n    >>> print """<xml xmlns="http://example.com"><tag   attr="bar"   /></xml>"""\n    <xml xmlns="...">\n      <tag attr="..." />\n    </xml>\n    >>> print """<xml>blahblahblah<foo /></xml>""" # doctest: +NOPARSE_MARKUP, +ELLIPSIS\n    <xml>...foo /></xml>\n    ' }
if __name__ == '__main__':
    import doctest
    doctest.testmod()

